# each dict key is a URL from api_skeleton.py,
# each dict value is a 2-item tupple: (oauth_leggedness, responseFormat), where:
#    oauth_leggedness is 2.0, 2.5 or 3.0.  2.5 means both 2-legged and 3-legged calls ar possible
#    resonseFormat is "XML", "JSON", "URL_ENCODED", "PLAIN_TEXT", or "unknown".
CALLS_AUX = {
    ("POST", "/accounts/") : (2.0, "XML"),
    ("GET", "/accounts/search") : (2.0, "XML"),
    ("GET", "/accounts/{ACCOUNT_EMAIL}") : (2.5, "XML"),
    ("POST", "/accounts/{ACCOUNT_EMAIL}/authsystems/") : (2.0, "ok"),
    ("POST", "/accounts/{ACCOUNT_EMAIL}/authsystems/password/change") : (3.0, "ok"),
    ("POST", "/accounts/{ACCOUNT_EMAIL}/authsystems/password/set") : (2.0, "ok"),
    ("POST", "/accounts/{ACCOUNT_EMAIL}/authsystems/password/set-username") : (2.5, "ok"),
    ("GET", "/accounts/{ACCOUNT_EMAIL}/check-secrets/{PRIMARY_SECRET}") : (2.0, "ok"),
    ("POST", "/accounts/{ACCOUNT_EMAIL}/forgot-password") : (2.0, "XML"),
    ("GET", "/accounts/{ACCOUNT_EMAIL}/inbox/") : (3.0, "XML"),
    ("POST", "/accounts/{ACCOUNT_EMAIL}/inbox/") : (2.0, "ok"),
    ("GET", "/accounts/{ACCOUNT_EMAIL}/inbox/{MESSAGE_ID}") : (3.0, "XML"),
    ("POST", "/accounts/{ACCOUNT_EMAIL}/inbox/{MESSAGE_ID}/archive") : (3.0, "ok"),
    ("POST", "/accounts/{ACCOUNT_EMAIL}/inbox/{MESSAGE_ID}/attachments/{ATTACHMENT_NUM}/accept") : (3.0, "ok"),
    ("POST", "/accounts/{ACCOUNT_EMAIL}/info-set") : (2.5, "ok"),
    ("POST", "/accounts/{ACCOUNT_EMAIL}/initialize/{PRIMARY_SECRET}") : (2.0, "ok"),
    ("GET", "/accounts/{ACCOUNT_EMAIL}/notifications/") : (3.0, "XML"),
    ("GET", "/accounts/{ACCOUNT_EMAIL}/permissions/") : (3.0, "XML"),
    ("GET", "/accounts/{ACCOUNT_EMAIL}/primary-secret") : (2.0, "XML"),
    ("GET", "/accounts/{ACCOUNT_EMAIL}/records/") : (3.0, "XML"),
    ("POST", "/accounts/{ACCOUNT_EMAIL}/reset") : (2.0, "ok"),
    ("GET", "/accounts/{ACCOUNT_EMAIL}/secret") : (2.0, "XML"),
    ("POST", "/accounts/{ACCOUNT_EMAIL}/secret-resend") : (2.0, "ok"),
    ("POST", "/accounts/{ACCOUNT_EMAIL}/set-state") : (2.0, "ok"),
    ("GET", "/apps/") : (2.0, "XML"),
    ("DELETE", "/apps/{PHA_EMAIL}") : (2.0, "ok"),
    ("GET", "/apps/{PHA_EMAIL}") : (2.0, "XML"),
    ("GET", "/apps/{PHA_EMAIL}/documents/") : (2.0, "XML"),
    ("POST", "/apps/{PHA_EMAIL}/documents/") : (2.0, "XML"),
    ("PUT", "/apps/{PHA_EMAIL}/documents/external/{EXTERNAL_ID}") : (2.0, "XML"),
    ("GET", "/apps/{PHA_EMAIL}/documents/external/{EXTERNAL_ID}/meta") : (2.0, "XML"),
    ("DELETE", "/apps/{PHA_EMAIL}/documents/{DOCUMENT_ID}") : (2.0, "ok"),
    ("GET", "/apps/{PHA_EMAIL}/documents/{DOCUMENT_ID}") : (2.0, "unknown"),
    ("PUT", "/apps/{PHA_EMAIL}/documents/{DOCUMENT_ID}") : (2.0, "XML"),
    ("PUT", "/apps/{PHA_EMAIL}/documents/{DOCUMENT_ID}/label") : (2.0, "XML"),
    ("GET", "/apps/{PHA_EMAIL}/documents/{DOCUMENT_ID}/meta") : (2.0, "XML"),
    ("DELETE", "/carenets/{CARENET_ID}") : (2.5, "ok"),
    ("GET", "/carenets/{CARENET_ID}/accounts/") : (2.5, "XML"),
    ("POST", "/carenets/{CARENET_ID}/accounts/") : (2.5, "ok"),
    ("DELETE", "/carenets/{CARENET_ID}/accounts/{ACCOUNT_ID}") : (2.5, "ok"),
    ("GET", "/carenets/{CARENET_ID}/accounts/{ACCOUNT_ID}/permissions") : (2.5, "XML"),
    ("GET", "/carenets/{CARENET_ID}/apps/") : (2.5, "XML"),
    ("DELETE", "/carenets/{CARENET_ID}/apps/{PHA_EMAIL}") : (2.5, "ok"),
    ("PUT", "/carenets/{CARENET_ID}/apps/{PHA_EMAIL}") : (2.5, "ok"),
    ("GET", "/carenets/{CARENET_ID}/apps/{PHA_EMAIL}/permissions") : (3.0, "ok"),
    ("GET", "/carenets/{CARENET_ID}/documents/") : (3.0, "XML"),
    ("GET", "/carenets/{CARENET_ID}/documents/special/{SPECIAL_DOCUMENT}") : (2.5, "XML"),
    ("GET", "/carenets/{CARENET_ID}/documents/{DOCUMENT_ID}") : (3.0, "unknown"),
    ("GET", "/carenets/{CARENET_ID}/documents/{DOCUMENT_ID}/meta") : (3.0, "XML"),
    ("GET", "/carenets/{CARENET_ID}/record") : (3.0, "XML"),
    ("POST", "/carenets/{CARENET_ID}/rename") : (2.5, "XML"),
    ("GET", "/carenets/{CARENET_ID}/reports/minimal/allergies/") : (3.0, "XML"),
    ("GET", "/carenets/{CARENET_ID}/reports/minimal/equipment/") : (3.0, "XML"),
    ("GET", "/carenets/{CARENET_ID}/reports/minimal/immunizations/") : (3.0, "XML"),
    ("GET", "/carenets/{CARENET_ID}/reports/minimal/labs/") : (3.0, "XML"),
    ("GET", "/carenets/{CARENET_ID}/reports/minimal/measurements/{LAB_CODE}/") : (3.0, "XML"),
    ("GET", "/carenets/{CARENET_ID}/reports/minimal/medications/") : (3.0, "XML"),
    ("GET", "/carenets/{CARENET_ID}/reports/minimal/problems/") : (3.0, "XML"),
    ("GET", "/carenets/{CARENET_ID}/reports/minimal/procedures/") : (3.0, "XML"),
    ("GET", "/carenets/{CARENET_ID}/reports/minimal/simple-clinical-notes/") : (3.0, "XML"),
    ("GET", "/carenets/{CARENET_ID}/reports/minimal/vitals/") : (3.0, "XML"),
    ("GET", "/carenets/{CARENET_ID}/reports/minimal/vitals/{CATEGORY}") : (3.0, "XML"),
    ("GET", "/codes/systems/") : (2.5, "unknown"),
    ("GET", "/codes/systems/{SYSTEM_SHORT_NAME}/query") : (2.5, "JSON"),
    ("POST", "/oauth/access_token") : (2.0, "URL_ENCODED"),
    ("POST", "/oauth/internal/request_tokens/{REQTOKEN_ID}/approve") : (3.0, "URL_ENCODED"),
    ("POST", "/oauth/internal/request_tokens/{REQTOKEN_ID}/claim") : (3.0, "PLAIN_TEXT"),
    ("GET", "/oauth/internal/request_tokens/{REQTOKEN_ID}/info") : (3.0, "XML"),
    ("POST", "/oauth/internal/session_create") : (2.0, "URL_ENCODED"),
    ("GET", "/oauth/internal/surl-verify") : (3.0, "XML"),
    ("POST", "/oauth/request_token") : (3.0, "URL_ENCODED"),
    ("POST", "/records/") : (2.0, "XML"),
    ("PUT", "/records/external/{PRINCIPAL_EMAIL}/{EXTERNAL_ID}") : (2.0, "XML"),
    ("GET", "/records/{RECORD_ID}") : (2.5, "XML"),
    ("GET", "/records/{RECORD_ID}/apps/") : (2.5, "XML"),
    ("DELETE", "/records/{RECORD_ID}/apps/{PHA_EMAIL}") : (2.5, "ok"),
    ("GET", "/records/{RECORD_ID}/apps/{PHA_EMAIL}") : (2.5, "XML"),
    ("GET", "/records/{RECORD_ID}/apps/{PHA_EMAIL}/documents/") : (3.0, "XML"),
    ("POST", "/records/{RECORD_ID}/apps/{PHA_EMAIL}/documents/") : (3.0, "XML"),
    ("POST", "/records/{RECORD_ID}/apps/{PHA_EMAIL}/documents/external/{EXTERNAL_ID}") : (3.0, "XML"),
    ("PUT", "/records/{RECORD_ID}/apps/{PHA_EMAIL}/documents/external/{EXTERNAL_ID}") : (3.0, "XML"),
    ("GET", "/records/{RECORD_ID}/apps/{PHA_EMAIL}/documents/external/{EXTERNAL_ID}/meta") : (3.0, "XML"),
    ("DELETE", "/records/{RECORD_ID}/apps/{PHA_EMAIL}/documents/{DOCUMENT_ID}") : (3.0, "ok"),
    ("GET", "/records/{RECORD_ID}/apps/{PHA_EMAIL}/documents/{DOCUMENT_ID}") : (3.0, "unknown"),
    ("PUT", "/records/{RECORD_ID}/apps/{PHA_EMAIL}/documents/{DOCUMENT_ID}/label") : (3.0, "XML"),
    ("GET", "/records/{RECORD_ID}/apps/{PHA_EMAIL}/documents/{DOCUMENT_ID}/meta") : (3.0, "XML"),
    ("POST", "/records/{RECORD_ID}/apps/{PHA_EMAIL}/setup") : (2.0, "URL_ENCODED"),
    ("GET", "/records/{RECORD_ID}/audits/") : (3.0, "XML"),
    ("GET", "/records/{RECORD_ID}/audits/documents/{DOCUMENT_ID}/") : (3.0, "XML"),
    ("GET", "/records/{RECORD_ID}/audits/documents/{DOCUMENT_ID}/functions/{FUNCTION_NAME}/") : (3.0, "XML"),
    ("GET", "/records/{RECORD_ID}/audits/query/") : (3.0, "XML"),
    ("GET", "/records/{RECORD_ID}/autoshare/bytype/") : (3.0, "XML"),
    ("GET", "/records/{RECORD_ID}/autoshare/bytype/all") : (3.0, "XML"),
    ("POST", "/records/{RECORD_ID}/autoshare/carenets/{CARENET_ID}/bytype/set") : (3.0, "ok"),
    ("POST", "/records/{RECORD_ID}/autoshare/carenets/{CARENET_ID}/bytype/unset") : (3.0, "ok"),
    ("GET", "/records/{RECORD_ID}/carenets/") : (2.5, "XML"),
    ("POST", "/records/{RECORD_ID}/carenets/") : (2.5, "XML"),
    ("DELETE", "/records/{RECORD_ID}/documents/") : (3.0, "ok"),
    ("GET", "/records/{RECORD_ID}/documents/") : (3.0, "XML"),
    ("POST", "/records/{RECORD_ID}/documents/") : (2.5, "XML"),
    ("PUT", "/records/{RECORD_ID}/documents/external/{PHA_EMAIL}/{EXTERNAL_ID}") : (3.0, "XML"),
    ("PUT", "/records/{RECORD_ID}/documents/external/{PHA_EMAIL}/{EXTERNAL_ID}/label") : (3.0, "XML"),
    ("GET", "/records/{RECORD_ID}/documents/external/{PHA_EMAIL}/{EXTERNAL_ID}/meta") : (3.0, "XML"),
    ("GET", "/records/{RECORD_ID}/documents/special/{SPECIAL_DOCUMENT}") : (2.5, "XML"),
    ("POST", "/records/{RECORD_ID}/documents/special/{SPECIAL_DOCUMENT}") : (2.5, "XML"),
    ("PUT", "/records/{RECORD_ID}/documents/special/{SPECIAL_DOCUMENT}") : (2.5, "XML"),
    ("PUT", "/records/{RECORD_ID}/documents/{DOCUMENT_ID_0}/rels/{REL}/{DOCUMENT_ID_1}") : (3.0, "ok"),
    ("GET", "/records/{RECORD_ID}/documents/{DOCUMENT_ID}") : (3.0, "unknown"),
    ("GET", "/records/{RECORD_ID}/documents/{DOCUMENT_ID}/carenets/") : (3.0, "XML"),
    ("DELETE", "/records/{RECORD_ID}/documents/{DOCUMENT_ID}/carenets/{CARENET_ID}") : (2.5, "ok"),
    ("PUT", "/records/{RECORD_ID}/documents/{DOCUMENT_ID}/carenets/{CARENET_ID}") : (2.5, "ok"),
    ("POST", "/records/{RECORD_ID}/documents/{DOCUMENT_ID}/carenets/{CARENET_ID}/autoshare-revert") : (3.0, "ok"),
    ("PUT", "/records/{RECORD_ID}/documents/{DOCUMENT_ID}/label") : (3.0, "XML"),
    ("GET", "/records/{RECORD_ID}/documents/{DOCUMENT_ID}/meta") : (3.0, "XML"),
    ("PUT", "/records/{RECORD_ID}/documents/{DOCUMENT_ID}/meta") : (3.0, "ok"),
    ("DELETE", "/records/{RECORD_ID}/documents/{DOCUMENT_ID}/nevershare") : (3.0, "ok"),
    ("PUT", "/records/{RECORD_ID}/documents/{DOCUMENT_ID}/nevershare") : (3.0, "ok"),
    ("GET", "/records/{RECORD_ID}/documents/{DOCUMENT_ID}/rels/{REL}/") : (3.0, "XML"),
    ("POST", "/records/{RECORD_ID}/documents/{DOCUMENT_ID}/rels/{REL}/") : (3.0, "ok"),
    ("POST", "/records/{RECORD_ID}/documents/{DOCUMENT_ID}/rels/{REL}/external/{PHA_EMAIL}/{EXTERNAL_ID}") : (3.0, "ok"),
    ("PUT", "/records/{RECORD_ID}/documents/{DOCUMENT_ID}/rels/{REL}/external/{PHA_EMAIL}/{EXTERNAL_ID}") : (3.0, "ok"),
    ("POST", "/records/{RECORD_ID}/documents/{DOCUMENT_ID}/replace") : (2.5, "XML"),
    ("PUT", "/records/{RECORD_ID}/documents/{DOCUMENT_ID}/replace/external/{PHA_EMAIL}/{EXTERNAL_ID}") : (3.0, "XML"),
    ("POST", "/records/{RECORD_ID}/documents/{DOCUMENT_ID}/set-status") : (3.0, "ok"),
    ("GET", "/records/{RECORD_ID}/documents/{DOCUMENT_ID}/status-history") : (3.0, "XML"),
    ("GET", "/records/{RECORD_ID}/documents/{DOCUMENT_ID}/versions/") : (3.0, "XML"),
    ("POST", "/records/{RECORD_ID}/inbox/{MESSAGE_ID}") : (2.5, "ok"),
    ("POST", "/records/{RECORD_ID}/inbox/{MESSAGE_ID}/attachments/{ATTACHMENT_NUM}") : (2.5, "ok"),
    ("POST", "/records/{RECORD_ID}/notifications/") : (2.5, "ok"),
    ("POST", "/records/{RECORD_ID}/notify") : (2.5, "ok"),
    ("GET", "/records/{RECORD_ID}/owner") : (2.5, "XML"),
    ("POST", "/records/{RECORD_ID}/owner") : (2.0, "XML"),
    ("PUT", "/records/{RECORD_ID}/owner") : (2.0, "XML"),
    ("GET", "/records/{RECORD_ID}/reports/experimental/ccr") : (3.0, "XML"),
    ("GET", "/records/{RECORD_ID}/reports/minimal/allergies/") : (3.0, "XML"),
    ("GET", "/records/{RECORD_ID}/reports/minimal/equipment/") : (3.0, "XML"),
    ("GET", "/records/{RECORD_ID}/reports/minimal/immunizations/") : (3.0, "XML"),
    ("GET", "/records/{RECORD_ID}/reports/minimal/labs/") : (3.0, "XML"),
    ("GET", "/records/{RECORD_ID}/reports/minimal/measurements/{LAB_CODE}/") : (3.0, "XML"),
    ("GET", "/records/{RECORD_ID}/reports/minimal/medications/") : (3.0, "XML"),
    ("GET", "/records/{RECORD_ID}/reports/minimal/problems/") : (3.0, "XML"),
    ("GET", "/records/{RECORD_ID}/reports/minimal/procedures/") : (3.0, "XML"),
    ("GET", "/records/{RECORD_ID}/reports/minimal/simple-clinical-notes/") : (3.0, "XML"),
    ("GET", "/records/{RECORD_ID}/reports/minimal/vitals/") : (3.0, "XML"),
    ("GET", "/records/{RECORD_ID}/reports/minimal/vitals/{CATEGORY}/") : (3.0, "XML"),
    ("GET", "/records/{RECORD_ID}/shares/") : (2.5, "XML"),
    ("POST", "/records/{RECORD_ID}/shares/") : (2.5, "ok"),
    ("DELETE", "/records/{RECORD_ID}/shares/{OTHER_ACCOUNT_ID}") : (2.5, "ok"),
    ("POST", "/records/{RECORD_ID}/shares/{OTHER_ACCOUNT_ID}/delete") : (2.5, "ok"),
    ("GET", "/version") : (2.0, "XML")
}
